# Method: projects.locations.recommenders.recommendations.list

- [HTTP request](https://docs.cloud.google.com/recommender/docs/reference/rest/v1beta1/projects.locations.recommenders.recommendations/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/recommender/docs/reference/rest/v1beta1/projects.locations.recommenders.recommendations/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/recommender/docs/reference/rest/v1beta1/projects.locations.recommenders.recommendations/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/recommender/docs/reference/rest/v1beta1/projects.locations.recommenders.recommendations/list#body.request_body)
- [Response body](https://docs.cloud.google.com/recommender/docs/reference/rest/v1beta1/projects.locations.recommenders.recommendations/list#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/recommender/docs/reference/rest/v1beta1/projects.locations.recommenders.recommendations/list#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/recommender/docs/reference/rest/v1beta1/projects.locations.recommenders.recommendations/list#body.aspect_1)

Lists recommendations for the specified Cloud Resource. Requires the recommender.\*.list IAM permission for the specified recommender.

### HTTP request

`GET https://recommender.googleapis.com/v1beta1/{parent=projects/*/locations/*/recommenders/*}/recommendations`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The container resource on which to execute the request. Acceptable formats: - `projects/[PROJECT_NUMBER]/locations/[LOCATION]/recommenders/[RECOMMENDER_ID]` - `projects/[PROJECT_ID]/locations/[LOCATION]/recommenders/[RECOMMENDER_ID]` - `billingAccounts/[BILLING_ACCOUNT_ID]/locations/[LOCATION]/recommenders/[RECOMMENDER_ID]` - `folders/[FOLDER_ID]/locations/[LOCATION]/recommenders/[RECOMMENDER_ID]` - `organizations/[ORGANIZATION_ID]/locations/[LOCATION]/recommenders/[RECOMMENDER_ID]` LOCATION here refers to GCP Locations: <https://cloud.google.com/about/locations/> RECOMMENDER_ID refers to supported recommenders: <https://cloud.google.com/recommender/docs/recommenders>. |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` Optional. The maximum number of results to return from this request. Non-positive values are ignored. If not specified, the server will determine the number of results to return. |
| `pageToken` | `string` Optional. If present, retrieves the next batch of results from the preceding call to this method. `pageToken` must be the value of `nextPageToken` from the previous response. The values of other method parameters must be identical to those in the previous call. |
| `filter` | `string` Filter expression to restrict the recommendations returned. Supported filter fields: - `stateInfo.state` - `recommenderSubtype` - `priority` - `targetResources` Examples: - `stateInfo.state = ACTIVE OR stateInfo.state = DISMISSED` - `recommenderSubtype = REMOVE_ROLE OR recommenderSubtype = REPLACE_ROLE` - `priority = P1 OR priority = P2` - `targetResources : //compute.googleapis.com/projects/1234/zones/us-central1-a/instances/instance-1` - `stateInfo.state = ACTIVE AND (priority = P1 OR priority = P2)` The max allowed filter length is 500 characters. (These expressions are based on the filter language described at <https://google.aip.dev/160>) |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/recommender/docs/reference/rest/v1beta1/ListRecommendationsResponse`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://cloud.google.com/docs/authentication/).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permissions on the `parent` resource:

- `recommender.usageCommitmentRecommendations.list`
- `recommender.computeAddressIdleResourceRecommendations.list`
- `recommender.computeDiskIdleResourceRecommendations.list`
- `recommender.computeImageIdleResourceRecommendations.list`
- `recommender.computeInstanceGroupManagerMachineTypeRecommendations.list`
- `recommender.computeInstanceIdleResourceRecommendations.list`
- `recommender.computeInstanceMachineTypeRecommendations.list`
- `recommender.iamPolicyRecommendations.list`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).